## mingw-w64-quantlib-1.36-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15.0)

# For MSVC RUNTIME LIBRARY, need CMP0091=NEW and cmake 3.15+
cmake_policy(SET CMP0091 NEW)

# Version info
set(QUANTLIB_VERSION_MAJOR 1)
set(QUANTLIB_VERSION_MINOR 36)
set(QUANTLIB_VERSION_PATCH 0)
set(QUANTLIB_VERSION ${QUANTLIB_VERSION_MAJOR}.${QUANTLIB_VERSION_MINOR}.${QUANTLIB_VERSION_PATCH})

# Project Info
set(PACKAGE_NAME          "QuantLib")
set(PACKAGE_VERSION       "${QUANTLIB_VERSION}")
set(PACKAGE_VERSION_HEX   "0x013600f0")
set(PACKAGE_STRING        "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_TARNAME       "${PACKAGE_NAME}-${PACKAGE_VERSION}")
set(PACKAGE_BUGREPORT     "https://github.com/lballabio/QuantLib/issues/")

# Default build type for single-config generators (set this before project() command)
# For multi-config generators, such as Visual Studio, use: cmake --build . --config=<CONFIG>
if (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
    set(CMAKE_BUILD_TYPE "Release" CACHE
        STRING "Build type for single-config generators" FORCE)
endif()

project(${PACKAGE_NAME} LANGUAGES CXX DESCRIPTION "The QuantLib C++ Library")

# Path for package-local cmake modules
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

# Installation directories
set(QL_INSTALL_BINDIR "bin" CACHE STRING "Installation directory for executables")
set(QL_INSTALL_LIBDIR "lib" CACHE STRING "Installation directory for libraries")
set(QL_INSTALL_INCLUDEDIR "include" CACHE STRING "Installation directory for headers")
set(QL_INSTALL_EXAMPLESDIR "lib/QuantLib/examples" CACHE STRING
    "Installation directory for examples")
set(QL_INSTALL_CMAKEDIR "lib/cmake/${PACKAGE_NAME}" CACHE STRING
    "Installation directory for CMake scripts")

# Options
option(QL_BUILD_EXAMPLES "Build examples" ON)
option(QL_BUILD_TEST_SUITE "Build test suite" ON)
option(QL_BUILD_FUZZ_TEST_SUITE "Build fuzz test suite" OFF) 
option(QL_ENABLE_OPENMP "Detect and use OpenMP" OFF)
option(QL_ENABLE_PARALLEL_UNIT_TEST_RUNNER "Enable the parallel unit test runner" OFF)
option(QL_ENABLE_SESSIONS "Singletons return different instances for different sessions" OFF)
option(QL_ENABLE_THREAD_SAFE_OBSERVER_PATTERN "Enable the thread-safe observer pattern" OFF)
option(QL_ENABLE_TRACING "Tracing messages should be allowed" OFF)
option(QL_ENABLE_DEFAULT_WARNING_LEVEL "Enable the default warning level to pass the ci pipeline" ON)
option(QL_COMPILE_WARNING_AS_ERROR "Specify whether to treat warnings on compile as errors." OFF)
option(QL_ERROR_FUNCTIONS "Error messages should include current function information" OFF)
option(QL_ERROR_LINES "Error messages should include file and line information" OFF)
option(QL_EXTRA_SAFETY_CHECKS "Extra safety checks should be performed" OFF)
option(QL_HIGH_RESOLUTION_DATE "Enable date resolution down to microseconds" OFF)
option(QL_THROW_IN_CYCLES "Throw an exception when a notification loop is detected" OFF)
option(QL_FASTER_LAZY_OBJECTS "Cause lazy objects to forward just the first notification instead of every one" ON)
option(QL_NULL_AS_FUNCTIONS "Enable the implementation of Null as template functions" OFF)
option(QL_INSTALL_BENCHMARK "Install benchmark" ON)
option(QL_INSTALL_EXAMPLES "Install examples" ON)
option(QL_INSTALL_TEST_SUITE "Install test suite" ON)
option(QL_TAGGED_LAYOUT "Library names use layout tags" ${MSVC})
option(QL_USE_CLANG_TIDY "Use clang-tidy when building" OFF)
option(QL_USE_INDEXED_COUPON "Use indexed coupons instead of par coupons" OFF)
option(QL_USE_STD_ANY "Use std::any instead of boost::any" OFF)
option(QL_USE_STD_CLASSES "Enable all QL_USE_STD_ options" OFF)
option(QL_USE_STD_OPTIONAL "Use std::optional instead of boost::optional" OFF)
option(QL_USE_STD_SHARED_PTR "Use standard smart pointers instead of Boost ones" OFF)
set(QL_EXTERNAL_SUBDIRECTORIES "" CACHE STRING "Optional list of external source directories to be added to the build (semicolon-separated)")
# set -lpapi here
set(QL_EXTRA_LINK_LIBRARIES "" CACHE STRING "Optional extra link libraries to add to QuantLib")

# Require C++17 or higher
if (NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
elseif(CMAKE_CXX_STANDARD LESS 17)
    message(FATAL_ERROR "Please specify CMAKE_CXX_STANDARD of 17 or higher")
endif()
if (NOT DEFINED CMAKE_CXX_STANDARD_REQUIRED)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
# Avoid use of compiler language extensions, i.e. -std=c++17 not -std=gnu++17
if (NOT DEFINED CMAKE_CXX_EXTENSIONS)
    set(CMAKE_CXX_EXTENSIONS FALSE)
endif()

# Convenience option to activate all STD options
if (QL_USE_STD_CLASSES)
    set(QL_USE_STD_ANY ON)
    set(QL_USE_STD_OPTIONAL ON)
    set(QL_USE_STD_SHARED_PTR ON)
endif()

# Set the default warning level we use to pass the GitHub workflows
if (QL_ENABLE_DEFAULT_WARNING_LEVEL)
    if (MSVC)
        # warning level 3
        # There are also specific warnings disabled for MSCV in cmake/Platform.cmake.
        add_compile_options(-W3)
    elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
        # lots of warnings
        add_compile_options(-Wall -Wno-unknown-pragmas -Wno-array-bounds)
    endif()
endif()

# Treat warnings on compile as errors
if (QL_COMPILE_WARNING_AS_ERROR)
    # all compiler warnings as errors
    if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
        # since v3.24 cmake can set all compiler warnings as errors itself
        set(CMAKE_COMPILE_WARNING_AS_ERROR ON)
    else()
        # or set them manually
        if (MSVC)
            add_compile_options(-WX)
        elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
            add_compile_options(-Werror)
        endif()
    endif()
endif()

if (QL_USE_CLANG_TIDY)
    if (NOT DEFINED QL_CLANG_TIDY)
        set(QL_CLANG_TIDY clang-tidy)
    endif()
    if (NOT DEFINED QL_CLANG_TIDY_OPTIONS)
        set(QL_CLANG_TIDY_OPTIONS)
    endif()
    if (QL_CLANG_TIDY_OPTIONS)
        set(CMAKE_CXX_CLANG_TIDY "${QL_CLANG_TIDY};${QL_CLANG_TIDY_OPTIONS}")
    else()
        set(CMAKE_CXX_CLANG_TIDY "${QL_CLANG_TIDY}")
    endif()
endif()

# Project shared libs ON for UNIX
if (NOT DEFINED BUILD_SHARED_LIBS)
    set(BUILD_SHARED_LIBS ${UNIX})
endif()

# Boost static libs ON for MSVC
if (NOT DEFINED Boost_USE_STATIC_LIBS)
    set(Boost_USE_STATIC_LIBS ${MSVC})
endif()

# Boost static runtime ON for MSVC
if (NOT DEFINED Boost_USE_STATIC_RUNTIME)
    set(Boost_USE_STATIC_RUNTIME ${MSVC})
endif()

if (NOT DEFINED QL_BOOST_VERSION)
    # Boost 1.75.0 or greater required for compiling with C++20
    if (CMAKE_CXX_STANDARD GREATER_EQUAL 20)
        set(QL_BOOST_VERSION 1.75.0)
    else()
        set(QL_BOOST_VERSION 1.58.0)
    endif()
endif()

if (CMAKE_CXX_COMPILER STREQUAL "icpx")
    find_package(IntelDPCPP REQUIRED)
endif()

find_package(Boost ${QL_BOOST_VERSION} REQUIRED)

# Do not warn about Boost versions higher than 1.58.0
set(Boost_NO_WARN_NEW_VERSIONS ON)

# Avoid using Boost auto-linking
add_compile_definitions(BOOST_ALL_NO_LIB)

if (QL_ENABLE_OPENMP)
    find_package(OpenMP REQUIRED)
endif()

# Prefer pthread flag as per https://cmake.org/cmake/help/latest/module/FindThreads.html
if (NOT DEFINED THREADS_PREFER_PTHREAD_FLAG)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
endif()

# Add Threads dependency when any of the threading features are enabled
if (QL_ENABLE_PARALLEL_UNIT_TEST_RUNNER OR QL_ENABLE_SESSIONS OR QL_ENABLE_THREAD_SAFE_OBSERVER_PATTERN)
    find_package(Threads REQUIRED)
    # Parallel test runner needs library rt on *nix for shm_open, etc.
    if (QL_ENABLE_PARALLEL_UNIT_TEST_RUNNER AND UNIX AND NOT APPLE)
        find_library(RT_LIBRARY rt REQUIRED)
        set(QL_THREAD_LIBRARIES Threads::Threads ${RT_LIBRARY})
    else()
        set(QL_THREAD_LIBRARIES Threads::Threads)
    endif()
endif()

# If available, use PIC for shared libs and PIE for executables
if (NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()
if (CMAKE_POSITION_INDEPENDENT_CODE)
    # cmake policy CMP0083: add PIE support if possible (need cmake 3.14)
    include(CheckPIESupported)
    check_pie_supported()
endif()

# Configure files
set(QL_HAVE_CONFIG_H ON)
set(QL_VERSION ${PACKAGE_VERSION})
set(QL_HEX_VERSION ${PACKAGE_VERSION_HEX})
configure_file(ql/config.hpp.cfg ql/config.hpp @ONLY)
configure_file(ql/qldefines.hpp.cfg ql/qldefines.hpp @ONLY)


# Generate quantlib-config
# Define the variables to be substituted in the input file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(includedir "\${prefix}/include")
set(libdir "\${exec_prefix}/lib")
configure_file(quantlib-config.in quantlib-config @ONLY)
configure_file(quantlib.pc.in quantlib.pc @ONLY)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/quantlib-config TYPE BIN)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/quantlib.pc DESTINATION lib/pkgconfig)

include(Platform)

# Check for library name layout tagging
if (QL_TAGGED_LAYOUT)
    if (${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        set(DEBUG_POSTFIX "-x64")
        set(RELEASE_POSTFIX "-x64")
    endif()
    set(DEBUG_POSTFIX ${DEBUG_POSTFIX}-mt)
    set(RELEASE_POSTFIX ${RELEASE_POSTFIX}-mt)
    if (CMAKE_MSVC_RUNTIME_LIBRARY MATCHES ".*DLL$")
        set(DEBUG_POSTFIX ${DEBUG_POSTFIX}-gd)
    else()
        set(DEBUG_POSTFIX ${DEBUG_POSTFIX}-sgd)
        set(RELEASE_POSTFIX ${RELEASE_POSTFIX}-s)
    endif()
    set(CMAKE_DEBUG_POSTFIX ${DEBUG_POSTFIX})
    set(CMAKE_RELEASE_POSTFIX ${RELEASE_POSTFIX})
    set(CMAKE_RELWITHDEBINFO_POSTFIX ${RELEASE_POSTFIX})
    set(CMAKE_MINSIZEREL_POSTFIX ${RELEASE_POSTFIX})
endif()

include(CTest)

# extension subdirectories if they exist (hook for external projects)
foreach(extdir ${QL_EXTERNAL_SUBDIRECTORIES})
    get_filename_component(name_without_dir "${extdir}" NAME)
    add_subdirectory(${extdir} ${name_without_dir})
endforeach()

# Add subdirectories
add_subdirectory(ql)
if (QL_BUILD_EXAMPLES)
    add_subdirectory(Examples)
endif()
if (QL_BUILD_TEST_SUITE)
    add_subdirectory(test-suite)
endif()

if ('${CMAKE_CXX_COMPILER_ID}' MATCHES 'Clang' AND  QL_BUILD_FUZZ_TEST_SUITE)
    add_subdirectory(fuzz-test-suite)
endif()

# CPack support (make package, make package_source)
set(CPACK_PACKAGE_VERSION_MAJOR ${QUANTLIB_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${QUANTLIB_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${QUANTLIB_VERSION_PATCH})
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
set(CPACK_GENERATOR "TGZ" "ZIP" "7Z")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
set(CPACK_SOURCE_GENERATOR "TGZ" "ZIP" "7Z")
set(CPACK_SOURCE_IGNORE_FILES
    "~$"
    "\\\\.swp$"
    "/[Bb]uild"
    "/\\\\.app"
    "/\\\\.cla"
    "/\\\\.cod"
    "/\\\\.git"
    "/\\\\.lgt"
    "/\\\\.mis")
include(CPack)

=== ql/CMakeLists.txt ===
set(QL_SOURCES
    cashflow.cpp
    cashflows/averagebmacoupon.cpp
    cashflows/capflooredcoupon.cpp
    cashflows/capflooredinflationcoupon.cpp
    cashflows/cashflows.cpp
    cashflows/cashflowvectors.cpp
    cashflows/cmscoupon.cpp
    cashflows/conundrumpricer.cpp
    cashflows/coupon.cpp
    cashflows/couponpricer.cpp
    cashflows/cpicoupon.cpp
    cashflows/cpicouponpricer.cpp
    cashflows/digitalcmscoupon.cpp
    cashflows/digitalcoupon.cpp
    cashflows/digitaliborcoupon.cpp
    cashflows/dividend.cpp
    cashflows/duration.cpp
    cashflows/equitycashflow.cpp
    cashflows/fixedratecoupon.cpp
    cashflows/floatingratecoupon.cpp
    cashflows/iborcoupon.cpp
    cashflows/indexedcashflow.cpp
    cashflows/inflationcoupon.cpp
    cashflows/inflationcouponpricer.cpp
    cashflows/lineartsrpricer.cpp
    cashflows/overnightindexedcoupon.cpp
    cashflows/overnightindexedcouponpricer.cpp
    cashflows/rangeaccrual.cpp
    cashflows/replication.cpp
    cashflows/simplecashflow.cpp
    cashflows/timebasket.cpp
    cashflows/subperiodcoupon.cpp
    cashflows/yoyinflationcoupon.cpp
    cashflows/zeroinflationcashflow.cpp
    currencies/africa.cpp
    currencies/america.cpp
    currencies/asia.cpp
    currencies/crypto.cpp
    currencies/europe.cpp
    currencies/exchangeratemanager.cpp
    currencies/oceania.cpp
    currency.cpp
    discretizedasset.cpp
    errors.cpp
    event.cpp
    exchangerate.cpp
    exercise.cpp
    experimental/asian/analytic_cont_geom_av_price_heston.cpp
    experimental/asian/analytic_discr_geom_av_price_heston.cpp
    experimental/averageois/arithmeticaverageois.cpp
    experimental/averageois/arithmeticoisratehelper.cpp
    experimental/averageois/makearithmeticaverageois.cpp
    experimental/barrieroption/mcdoublebarrierengine.cpp
    experimental/barrieroption/discretizeddoublebarrieroption.cpp
    experimental/barrieroption/perturbativebarrieroptionengine.cpp
    experimental/barrieroption/quantodoublebarrieroption.cpp
    experimental/barrieroption/suowangdoublebarrierengine.cpp
    experimental/barrieroption/vannavolgabarrierengine.cpp
    experimental/basismodels/swaptioncfs.cpp
    experimental/basismodels/tenoroptionletvts.cpp
    experimental/basismodels/tenorswaptionvts.cpp
    experimental/callablebonds/blackcallablebondengine.cpp
    experimental/callablebonds/callablebond.cpp
    experimental/callablebonds/callablebondconstantvol.cpp
    experimental/callablebonds/callablebondvolstructure.cpp
    experimental/callablebonds/discretizedcallablefixedratebond.cpp
    experimental/callablebonds/treecallablebondengine.cpp
    experimental/catbonds/catbond.cpp
    experimental/catbonds/catrisk.cpp
    experimental/catbonds/montecarlocatbondengine.cpp
    experimental/catbonds/riskynotional.cpp
    experimental/commodities/commodity.cpp
    experimental/commodities/commoditycashflow.cpp
    experimental/commodities/commoditycurve.cpp
    experimental/commodities/commodityindex.cpp
    experimental/commodities/commoditypricinghelpers.cpp
    experimental/commodities/commoditysettings.cpp
    experimental/commodities/commoditytype.cpp
    experimental/commodities/commodityunitcost.cpp
    experimental/commodities/dateinterval.cpp
    experimental/commodities/energybasisswap.cpp
    experimental/commodities/energycommodity.cpp
    experimental/commodities/energyfuture.cpp
    experimental/commodities/energyswap.cpp
    experimental/commodities/energyvanillaswap.cpp
    experimental/commodities/paymentterm.cpp
    experimental/commodities/quantity.cpp
    experimental/commodities/unitofmeasure.cpp
    experimental/commodities/unitofmeasureconversion.cpp
    experimental/commodities/unitofmeasureconversionmanager.cpp
    experimental/coupons/cmsspreadcoupon.cpp
    experimental/coupons/digitalcmsspreadcoupon.cpp
    experimental/coupons/lognormalcmsspreadpricer.cpp
    experimental/coupons/proxyibor.cpp
    experimental/coupons/quantocouponpricer.cpp
    experimental/coupons/strippedcapflooredcoupon.cpp
    experimental/coupons/swapspreadindex.cpp
    experimental/credit/basecorrelationstructure.cpp
    experimental/credit/basket.cpp
    experimental/credit/blackcdsoptionengine.cpp
    experimental/credit/cdo.cpp
    experimental/credit/cdsoption.cpp
    experimental/credit/correlationstructure.cpp
    experimental/credit/defaultevent.cpp
    experimental/credit/defaultprobabilitykey.cpp
    experimental/credit/defaulttype.cpp
    experimental/credit/distribution.cpp
    experimental/credit/gaussianlhplossmodel.cpp
    experimental/credit/integralcdoengine.cpp
    experimental/credit/integralntdengine.cpp
    experimental/credit/issuer.cpp
    experimental/credit/lossdistribution.cpp
    experimental/credit/midpointcdoengine.cpp
    experimental/credit/nthtodefault.cpp
    experimental/credit/onefactorcopula.cpp
    experimental/credit/onefactorgaussiancopula.cpp
    experimental/credit/onefactorstudentcopula.cpp
    experimental/credit/pool.cpp
    experimental/credit/randomdefaultmodel.cpp
    experimental/credit/recoveryratemodel.cpp
    experimental/credit/recoveryratequote.cpp
    experimental/credit/riskyassetswap.cpp
    experimental/credit/riskyassetswapoption.cpp
    experimental/credit/syntheticcdo.cpp
    experimental/exoticoptions/analyticholderextensibleoptionengine.cpp
    experimental/exoticoptions/analyticpartialtimebarrieroptionengine.cpp
    experimental/exoticoptions/analyticpdfhestonengine.cpp
    experimental/exoticoptions/analytictwoassetbarrierengine.cpp
    experimental/exoticoptions/analytictwoassetcorrelationengine.cpp
    experimental/exoticoptions/analyticwriterextensibleoptionengine.cpp
    experimental/exoticoptions/continuousarithmeticasianlevyengine.cpp
    experimental/exoticoptions/continuousarithmeticasianvecerengine.cpp
    experimental/exoticoptions/everestoption.cpp
    experimental/exoticoptions/himalayaoption.cpp
    experimental/exoticoptions/holderextensibleoption.cpp
    experimental/exoticoptions/kirkspreadoptionengine.cpp
    experimental/exoticoptions/mceverestengine.cpp
    experimental/exoticoptions/mchimalayaengine.cpp
    experimental/exoticoptions/mcpagodaengine.cpp
    experimental/exoticoptions/pagodaoption.cpp
    experimental/exoticoptions/partialtimebarrieroption.cpp
    experimental/exoticoptions/twoassetbarrieroption.cpp
    experimental/exoticoptions/twoassetcorrelationoption.cpp
    experimental/exoticoptions/writerextensibleoption.cpp
    experimental/finitedifferences/dynprogvppintrinsicvalueengine.cpp
    experimental/finitedifferences/fdextoujumpvanillaengine.cpp
    experimental/finitedifferences/fdklugeextouspreadengine.cpp
    experimental/finitedifferences/fdmdupire1dop.cpp
    experimental/finitedifferences/fdmextendedornsteinuhlenbeckop.cpp
    experimental/finitedifferences/fdmextoujumpop.cpp
    experimental/finitedifferences/fdmextoujumpsolver.cpp
    experimental/finitedifferences/fdmklugeextouop.cpp
    experimental/finitedifferences/fdmvppstartlimitstepcondition.cpp
    experimental/finitedifferences/fdmvppstepcondition.cpp
    experimental/finitedifferences/fdmvppstepconditionfactory.cpp
    experimental/finitedifferences/fdmzabrop.cpp
    experimental/finitedifferences/fdornsteinuhlenbeckvanillaengine.cpp
    experimental/finitedifferences/fdsimpleextoujumpswingengine.cpp
    experimental/finitedifferences/fdsimpleextoustorageengine.cpp
    experimental/finitedifferences/fdsimpleklugeextouvppengine.cpp
    experimental/finitedifferences/glued1dmesher.cpp
    experimental/finitedifferences/vanillavppoption.cpp
    experimental/forward/analytichestonforwardeuropeanengine.cpp
    experimental/fx/blackdeltacalculator.cpp
    experimental/fx/deltavolquote.cpp
    experimental/inflation/cpicapfloorengines.cpp
    experimental/inflation/cpicapfloortermpricesurface.cpp
    experimental/inflation/yoycapfloortermpricesurface.cpp
    experimental/inflation/yoyoptionlethelpers.cpp
    experimental/lattices/extendedbinomialtree.cpp
    experimental/math/convolvedstudentt.cpp
    experimental/math/fireflyalgorithm.cpp
    experimental/math/gaussiancopulapolicy.cpp
    experimental/math/gaussiannoncentralchisquaredpolynomial.cpp
    experimental/math/laplaceinterpolation.cpp
    experimental/math/multidimintegrator.cpp
    experimental/math/multidimquadrature.cpp
    experimental/math/particleswarmoptimization.cpp
    experimental/math/piecewiseintegral.cpp
    experimental/math/tcopulapolicy.cpp
    experimental/math/zigguratrng.cpp
    experimental/mcbasket/adaptedpathpayoff.cpp
    experimental/mcbasket/longstaffschwartzmultipathpricer.cpp
    experimental/mcbasket/mcpathbasketengine.cpp
    experimental/mcbasket/pathmultiassetoption.cpp
    experimental/models/normalclvmodel.cpp
    experimental/models/squarerootclvmodel.cpp
    experimental/processes/extendedblackscholesprocess.cpp
    experimental/processes/extendedornsteinuhlenbeckprocess.cpp
    experimental/processes/extouwithjumpsprocess.cpp
    experimental/processes/gemanroncoroniprocess.cpp
    experimental/processes/klugeextouprocess.cpp
    experimental/processes/vegastressedblackscholesprocess.cpp
    experimental/risk/creditriskplus.cpp
    experimental/risk/sensitivityanalysis.cpp
    experimental/shortrate/generalizedhullwhite.cpp
    experimental/shortrate/generalizedornsteinuhlenbeckprocess.cpp
    experimental/swaptions/haganirregularswaptionengine.cpp
    experimental/swaptions/irregularswap.cpp
    experimental/swaptions/irregularswaption.cpp
    experimental/termstructures/basisswapratehelpers.cpp
    experimental/termstructures/crosscurrencyratehelpers.cpp
    experimental/variancegamma/analyticvariancegammaengine.cpp
    experimental/variancegamma/fftengine.cpp
    experimental/variancegamma/fftvanillaengine.cpp
    experimental/variancegamma/fftvariancegammaengine.cpp
    experimental/variancegamma/variancegammamodel.cpp
    experimental/variancegamma/variancegammaprocess.cpp
    experimental/varianceoption/integralhestonvarianceoptionengine.cpp
    experimental/varianceoption/varianceoption.cpp
    experimental/volatility/abcdatmvolcurve.cpp
    experimental/volatility/blackatmvolcurve.cpp
    experimental/volatility/blackvolsurface.cpp
    experimental/volatility/equityfxvolsurface.cpp
    experimental/volatility/extendedblackvariancecurve.cpp
    experimental/volatility/extendedblackvariancesurface.cpp
    experimental/volatility/interestratevolsurface.cpp
    experimental/volatility/noarbsabr.cpp
    experimental/volatility/noarbsabrabsprobs.cpp
    experimental/volatility/noarbsabrinterpolatedsmilesection.cpp
    experimental/volatility/noarbsabrsmilesection.cpp
    experimental/volatility/sabrvolsurface.cpp
    experimental/volatility/sviinterpolatedsmilesection.cpp
    experimental/volatility/svismilesection.cpp
    experimental/volatility/volcube.cpp
    experimental/volatility/zabr.cpp
    index.cpp
    indexes/bmaindex.cpp
    indexes/equityindex.cpp
    indexes/ibor/bibor.cpp
    indexes/ibor/corra.cpp
    indexes/ibor/eonia.cpp
    indexes/ibor/estr.cpp
    indexes/ibor/euribor.cpp
    indexes/ibor/eurlibor.cpp
    indexes/ibor/fedfunds.cpp
    indexes/ibor/libor.cpp
    indexes/ibor/shibor.cpp
    indexes/ibor/sofr.cpp
    indexes/ibor/sonia.cpp
    indexes/iborindex.cpp
    indexes/indexmanager.cpp
    indexes/inflationindex.cpp
    indexes/interestrateindex.cpp
    indexes/region.cpp
    indexes/swap/chfliborswap.cpp
    indexes/swap/euriborswap.cpp
    indexes/swap/eurliborswap.cpp
    indexes/swap/gbpliborswap.cpp
    indexes/swap/jpyliborswap.cpp
    indexes/swap/usdliborswap.cpp
    indexes/swapindex.cpp
    instrument.cpp
    instruments/asianoption.cpp
    instruments/assetswap.cpp
    instruments/averagetype.cpp
    instruments/barrieroption.cpp
    instruments/barriertype.cpp
    instruments/basketoption.cpp
    instruments/bmaswap.cpp
    instruments/bond.cpp
    instruments/bondforward.cpp
    instruments/bonds/amortizingcmsratebond.cpp

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=quantlib
_srcname=QuantLib
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.36
pkgrel=1
pkgdesc="A free/open-source library for quantitative finance. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://www.quantlib.org/"
msys2_repository_url="https://github.com/lballabio/QuantLib"
msys2_references=(
  'aur: quantlib'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-omp")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost")
source=("https://github.com/lballabio/QuantLib/releases/download/v${pkgver}/${_srcname}-${pkgver}.tar.gz"
        "001-fix-install-destination.patch")
sha256sums=('a0eff3d420cc26c21ab8e55d3fd169448abe631a0fbc9f528a6ac444227824fa'
            'b78988a1fc82eb1d4cafead9abc5e685d5618e50df27f7f093c32962fe2915d5')

prepare() {
  cd ${_srcname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-install-destination.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_CXX_STANDARD=17 \
    -DQL_ENABLE_DEFAULT_WARNING_LEVEL=OFF \
    -DBUILD_SHARED_LIBS=ON \
    -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -DQL_USE_STD_CLASSES=ON \
    -DQL_BUILD_BENCHMARK=OFF \
    -DQL_INSTALL_BENCHMARK=OFF \
    -DQL_BUILD_EXAMPLES=OFF \
    -DQL_INSTALL_EXAMPLES=OFF \
    -DQL_BUILD_TEST_SUITE=OFF \
    -DQL_INSTALL_TEST_SUITE=OFF \
    -DQL_ENABLE_OPENMP=ON \
    ../${_srcname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  # Fix cmake-config files
  local WINPREFIX=$(cygpath -wm ${MINGW_PREFIX})
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake" -type f -name '*.cmake' \
    -exec sed -i -e "s|${WINPREFIX}|\$\{_IMPORT_PREFIX\}|g" {} \;

  install -Dm644 ${srcdir}/${_srcname}-${pkgver}/LICENSE.TXT "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}/LICENSE
}
